//必要なメソッドをグローバルビルドから分割代入で取得
const { ref, onUpdated } = Vue;

import { useModal } from '../composables/use_modal.js';

// コンポーネントを定義してエクスポート
export const Modal =
{
	props			:
	{
//		title		: String ,
//		msg			: String ,
	},
	setup( props , context )
	{
		const modal = useModal();

		const closeModal = () =>
		{
			//モーダルを閉じる
			modal.dialog = false;

			//URLが指定されていれば
			if( modal.url )
			{
				location.href = modal.url;
			}

		};

		return { modal , closeModal };
	},
	data			: () =>
	({

	}) ,
	methods			:
	{

	} ,
	template		: `

<!-- 結果ダイアログ -->
<v-dialog
 v-model="modal.dialog"
 persistent
 max-width="600"
>
	<v-card>
		<v-toolbar
		 color="blue-darken-4"
		 :title="modal.title"
		></v-toolbar>

		<v-card-text v-html="modal.msg"></v-card-text>

		<v-card-actions>

			<v-spacer></v-spacer>

			<v-btn
			 color="blue-darken-4"
			 variant="outlined"
			 @click="closeModal"
			>
			はい
			</v-btn>

		</v-card-actions>

	</v-card>
</v-dialog>
<!-- /結果ダイアログ -->


<!-- ローディングモーダル -->
<v-dialog
 v-model="modal.loading"
 :scrim="false"
 persistent
 max-width="600"
>
	<v-card
	 color="light-blue-darken-4"
	>
		<v-card-text>
		 {{modal.loading_title}}
			<v-progress-linear
			 indeterminate
			 color="white"
			 class="mb-0"
			></v-progress-linear>
		</v-card-text>
	</v-card>
</v-dialog>
<!-- /ローディングモーダル -->
`
};
