const { defineStore } = Pinia;

export const useValidateRules = defineStore( 'rules' ,
{
	state			: () =>
	({
		requireRules:
		[
			v		=> !!v || '入力必須項目です' ,	//二重否定でBooleanに変換して評価
		],
		minLenRules:
		[
			v		=> (v && v.length <= 10) || '10文字以下です' ,
		],
		mailRules	:
		[
			v		=> !!v || '入力必須項目です' ,	//二重否定でBooleanに変換して評価
			v		=> 
			{
				const pat = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
				return pat.test( v ) || 'メールアドレスの形式が間違っています'
			} ,
		],
		checkRules	:
		[
			v		=> !!v || 'チェックが必要です'
		],

	}),
	actions			:
	{

	}
});
