//必要なメソッドをグローバルビルドから分割代入で取得
const { ref, onUpdated , onMounted } = Vue;

import { useValidateRules } from '../../composables/use_validate_rules.js';
import { Modal } from '../../components/Modal.js';
import { useModal } from '../../composables/use_modal.js';

// コンポーネントを定義してエクスポート
export const DownloadLists =
{
	props			:
	{
//		parent		: String
	},
	setup( props , context )
	{
		const H_lists	= ref( null );

		//バリデートオブジェクトを取得
		const rurles = useValidateRules();

		//モーダルオブジェクトを取得
		const modal = useModal();


		//マウントされたら
		onMounted( async ()=>
		{
			modal.loading= true;

			//axiosのPOSTタイプではURLSearchParamsが必要
			const params = new URLSearchParams();
			params.append( 'action' , ACTION );
			params.append( 'name1' , NAME1 );
			params.append( 'name2' , NAME2 );
			params.append( 'mail' , MAIL );
			params.append( 'admin_mail' , ADMIN_MAIL );
			params.append( 'domain' , DOMAIN );
			params.append( 'token' , TOKEN );

			await axios.post( END_POINT , params )
			.then( res => 
			{
				modal.loading= false;

				console.log( res.data );

				//結果ダイアログを表示する
				modal.title	= res.data.title;
				modal.msg	= res.data.msg;
				modal.dialog= true;

				//リストの取得に成功すれば
				if( res.data.status )
				{
					H_lists.value	= res.data.H_lists;
				}

			})
			.catch( error => 
			{
				modal.loading= false;

				alert( "エラーが発生しました。" );
				console.log( error );
			});

		});


		//AJAXでダウンロードする
		const download = async ( item_id , item_name )=>
		{
			if(! item_id )
			{
				//結果ダイアログを表示する
				modal.title	= 'エラー';
				modal.msg	= 'item_idが取得できませんでした。';
				modal.dialog= true;

				return false;
			}

			modal.loading= true;

			//axiosのPOSTタイプではURLSearchParamsが必要
			const params = new URLSearchParams();
			params.append( 'action' , ACTION2 );
			params.append( 'name1' , NAME1 );
			params.append( 'name2' , NAME2 );
			params.append( 'mail' , MAIL );
			params.append( 'admin_mail' , ADMIN_MAIL );
			params.append( 'domain' , DOMAIN );
			params.append( 'token' , TOKEN );
			params.append( 'item_id' , item_id );
			params.append( 'item_name' , item_name );

			await axios.post( END_POINT , params )
			.then( res => 
			{
				modal.loading= false;

				console.log( res.data );

				//結果ダイアログを表示する
				modal.title	= res.data.title;
				modal.msg	= res.data.msg;
				modal.dialog= true;

				if( res.data.status )
				{

				}

			})
			.catch( error => 
			{
				modal.loading= false;

				alert( "エラーが発生しました。" );
				console.log( error );
			});

		};



		return {
			H_lists ,
			download ,
			rurles ,
			modal ,
		};
	},
	data			: () =>
	({

	}) ,
	methods			:
	{

	} ,
	components		:
	{
		'app-modal'	: Modal ,
	},
	template		: `

<!-- プラグインリスト -->
<v-card class="mx-auto my-8 px-6 py-8" width="960" max-width="960">

	<v-row>
		<v-col
		 v-for="n in H_lists"
		 :key="n"
		>

			<v-card
			 class="mx-auto"
			>
				<v-img
				 :src="n.item_img"
				 cover
				></v-img>

				<v-card-title>
				 {{n.item_name}}
				</v-card-title>

				<v-card-actions>
					<v-btn
					 class="ml-2"
					 color="green"
					 variant="outlined"
					 @click="download( n.item_id , n.item_name )"
					>
					 ダウンロード
					</v-btn>

					<v-spacer></v-spacer>

					<v-btn
					 :prepend-icon="n.show ? 'mdi-chevron-up' : 'mdi-chevron-down'"
					 color="blue-grey"
					 @click="n.show = !n.show"
					>説明を読む</v-btn>
				</v-card-actions>

				<v-expand-transition>
					<div v-show="n.show">
						<v-divider></v-divider>
						<v-card-text v-html="n.item_desc"></v-card-text>
					</div>
				</v-expand-transition>

			</v-card>

		</v-col>
	</v-row>


</v-card>
<!-- /プラグインリスト -->

<!-- モーダル -->
<app-modal />
<!-- /モーダル -->

`
};
