//必要なメソッドをグローバルビルドから分割代入で取得
const { ref, onUpdated , onMounted } = Vue;

import { useValidateRules } from '../../composables/use_validate_rules.js';
import { Modal } from '../../components/Modal.js';
import { useModal } from '../../composables/use_modal.js';

// コンポーネントを定義してエクスポート
export const PurchaseLicence =
{
	props			:
	{
//		parent		: String
	},
	setup( props , context )
	{
		const H_licence	= ref( null );

		//バリデートオブジェクトを取得
		const rurles = useValidateRules();

		//モーダルオブジェクトを取得
		const modal = useModal();

		//マウントされたら
		onMounted( async ()=>
		{
			modal.loading= true;

			//axiosのPOSTタイプではURLSearchParamsが必要
			const params = new URLSearchParams();
			params.append( 'action' , ACTION );
			params.append( 'name1' , NAME1 );
			params.append( 'name2' , NAME2 );
			params.append( 'mail' , MAIL );
			params.append( 'admin_mail' , ADMIN_MAIL );
			params.append( 'domain' , DOMAIN );
			params.append( 'token' , TOKEN );

			await axios.post( END_POINT , params )
			.then( res => 
			{
				modal.loading= false;

				console.log( res.data );

				//結果ダイアログを表示する
				modal.title	= res.data.title;
				modal.msg	= res.data.msg;
				modal.dialog= true;

				//リストの取得に成功すれば
				if( res.data.status )
				{
					H_licence.value	= res.data.H_licence;
				}

			})
			.catch( error => 
			{
				modal.loading= false;

				alert( "エラーが発生しました。" );
				console.log( error );
			});

		});



		return {
			H_licence ,
			rurles ,
			modal ,
		};
	},
	data			: () =>
	({

	}) ,
	methods			:
	{

	} ,
	components		:
	{
		'app-modal'	: Modal ,
	},
	template		: `

<!-- ライセンス購入情報 -->
<v-card class="mx-auto my-8 px-6 py-8" width="960" max-width="960">

	<v-row>
		<v-col
		 v-for="n in H_licence"
		 :key="n"
		>

			<v-card
			 class="mx-auto"
			>
				<a :href="n.item_url" target="_blank">
					<v-img
					 :src="n.item_img"
					 cover
					></v-img>
				</a>

				<v-card-title>
					 <a :href="n.item_url" target="_blank" class="text-decoration-none">
						{{n.item_name}}
					</a>
				</v-card-title>

				<v-card-actions>
					<v-spacer></v-spacer>

					<v-btn
					 :prepend-icon="n.show ? 'mdi-chevron-up' : 'mdi-chevron-down'"
					 color="blue-grey"
					 @click="n.show = !n.show"
					>説明を読む</v-btn>
				</v-card-actions>

				<v-expand-transition>
					<div v-show="n.show">
						<v-divider></v-divider>
						<v-card-text v-html="n.item_desc"></v-card-text>
					</div>
				</v-expand-transition>

			</v-card>

		</v-col>
	</v-row>


</v-card>
<!-- ライセンス購入情報 -->

<!-- モーダル -->
<app-modal />
<!-- /モーダル -->

`
};
